/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JDialog.java to edit this template
 */
package vista;

import controlador.SucursalControl;
import controlador.ed.lista.exception.PosicionException;
import controlador.ed.lista.exception.VacioException;
import controlador.exception.EsapacioException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import modelo.Venta;
import vista.modeloTabla.ModeloTablaVentas;

/**
 *
 * @author Usuario
 */
public class FrmVentas extends javax.swing.JDialog {
    
    private ModeloTablaVentas modelo = new ModeloTablaVentas();
    private SucursalControl control;
    private int fila = -1;

    /**
     * Creates new form FrmVentanas
     */
    public FrmVentas(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }
    
    public FrmVentas(java.awt.Frame parent, boolean modal, SucursalControl sc) {
        super(parent, modal);
        initComponents();
        this.control = sc;
        lblsucursal.setText(sc.getSucursal().getNombre());
        cargarTabla();
    }
    
    private void cargarTabla(){
        tbltabla.setModel(modelo);
        tbltabla.updateUI();
    }
    
    private void limpiar(){
        this.control.setVenta(null);
        txtvalor.setText("");
        lblmes.setText("");
        fila = -1;
        cargarTabla();
    }
    private void cargarVenta() throws VacioException{
        fila = tbltabla.getSelectedRow();
        if(fila >= 0){
            txtvalor.setText(this.control.getVenta().getValor() + " ");
            lblmes.setText(this.control.getVenta().getMes().toString());
        }else
             JOptionPane.showMessageDialog(null, "Seleccione una ventana de la tabla", "Error",JOptionPane.ERROR_MESSAGE );
    }
    
    private void modificar() throws VacioException, PosicionException {
        if (!txtvalor.getText().trim().isEmpty() && !lblmes.getText().trim().isEmpty()) {
            Venta v = new Venta();
            v.setId(control.getVenta().getId());
            v.setMes(control.getVenta().getMes());
            v.setValor(Double.parseDouble(txtvalor.getText()));
            control.getVentas().modificar(v, fila);
            this.limpiar();
            JOptionPane.showMessageDialog(null, "Se han actualizado", "Message", JOptionPane.INFORMATION_MESSAGE);
        } else {
            JOptionPane.showMessageDialog(null, "Seleccione una ventana de la tabla", "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        lblsucursal = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        lblmes = new javax.swing.JLabel();
        txtvalor = new javax.swing.JTextField();
        btnguardar = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tbltabla = new javax.swing.JTable();
        btnseleccionar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(null);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Venta"));
        jPanel1.setLayout(null);

        jPanel2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel2.setLayout(null);

        jLabel1.setText("Nombre Sucursal:");
        jPanel2.add(jLabel1);
        jLabel1.setBounds(40, 30, 100, 18);

        lblsucursal.setText("<nombre de sucursal>");
        jPanel2.add(lblsucursal);
        lblsucursal.setBounds(150, 30, 200, 18);

        jPanel1.add(jPanel2);
        jPanel2.setBounds(20, 30, 420, 80);

        jPanel3.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel3.setLayout(null);

        jLabel2.setText("Mes:");
        jPanel3.add(jLabel2);
        jLabel2.setBounds(20, 20, 70, 18);

        jLabel3.setText("Valor: ");
        jPanel3.add(jLabel3);
        jLabel3.setBounds(180, 20, 50, 18);

        lblmes.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jPanel3.add(lblmes);
        lblmes.setBounds(60, 20, 100, 20);
        jPanel3.add(txtvalor);
        txtvalor.setBounds(250, 20, 110, 24);

        btnguardar.setText("Guardar");
        btnguardar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnguardarActionPerformed(evt);
            }
        });
        jPanel3.add(btnguardar);
        btnguardar.setBounds(160, 60, 83, 24);

        jPanel1.add(jPanel3);
        jPanel3.setBounds(20, 130, 410, 90);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(10, 10, 460, 240);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Tabla"));
        jPanel4.setLayout(null);

        tbltabla.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(tbltabla);

        jPanel4.add(jScrollPane1);
        jScrollPane1.setBounds(20, 30, 410, 160);

        btnseleccionar.setText("Seleccionar");
        btnseleccionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnseleccionarActionPerformed(evt);
            }
        });
        jPanel4.add(btnseleccionar);
        btnseleccionar.setBounds(20, 210, 120, 24);

        getContentPane().add(jPanel4);
        jPanel4.setBounds(10, 250, 460, 290);

        setSize(new java.awt.Dimension(509, 559));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btnseleccionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnseleccionarActionPerformed
        
        try {
            cargarVenta();
        } catch (VacioException ex) {
            Logger.getLogger(FrmVentas.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }//GEN-LAST:event_btnseleccionarActionPerformed

    private void btnguardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnguardarActionPerformed
        try {
            modificar();
        } catch (VacioException ex) {
            Logger.getLogger(FrmVentas.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PosicionException ex) {
            Logger.getLogger(FrmVentas.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_btnguardarActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrmVentas.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrmVentas.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrmVentas.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrmVentas.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                FrmVentas dialog = new FrmVentas(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnguardar;
    private javax.swing.JButton btnseleccionar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblmes;
    private javax.swing.JLabel lblsucursal;
    private javax.swing.JTable tbltabla;
    private javax.swing.JTextField txtvalor;
    // End of variables declaration//GEN-END:variables
}
